%--------------------------------------------
%Nome Jos Nuno Almeida Dias Bueno, 7117308
%SEL0382 - Controle Robusto
%Prof. Vilma Alves de Oliveira
%--------------------------------------------

%Exerccio de aula - Observador de Estado

%--------------------------------------------

close all
clear all

%Parmetros do navio
M = 10^7;   %Momento de inrcia do navio, em kg*m^2
d = 10^6;   %coeficiente de arrasto associado  rotao, em N*m*s/rad
c = 5000;   %coeficiente relacionando o ngulo do leme ao torque aplicado, em N*m/rad
%O ngulo theta (ngulo entre o curso atual e o desejado) seria medido por uma bssola.

%Matrizes do espao de estados:
A = [0 1 0; 0 -d/M -c/M; 0 0 -0.1];
B = [0 0; 1/M 0; 0 0.1];    %B = [B1 B2].

B1 = [0; 1/M; 0];  %Multiplica a entrada de controle alphac(t) = u(t).
B2 = [0; 0; 0.1]; %Multiplica a entrada de perturbao w(t).

C = [1 0 0];    %Devemos usar C = eye(3) no Simulink para no haver problemas de dimenso.

D = [0 0; 0 0; 0 0];


%Lei de realimentao de estado u = -Kc*x.
P1 = [-0.02 -0.02 -0.1];    %Primeiro conjunto de polos do item 2 do exerccio.
P2 = [-0.02+0.03*i -0.02-0.03*i -0.1];    %Segundo conjunto de polos do item 2 do exerccio.

Kc1 = acker(A, B2, P1);  %Lei de realimentao de estado para o primeiro conjunto de polos (P1);
Kc2 = acker(A, B2, P2);  %Lei de realimentao de estado para o segundo conjunto de polos (P2);

%--------------------------------------------
%Ganho Kf do observador de estado
P1f = [-0.08 -0.08 -0.4];    %Primeiro conjunto de polos do item 4 do exerccio.
P2f = [-0.16 -0.16 -0.4];    %Segundo conjunto de polos do item 4 do exerccio.

%Equao caracterstico desejado (usando os polos de P1f e P2f):
eqchar_1 = poly(P1f);    %Coeficientes da equao caracterstica com os polos P1f. Polinomio caracterstico - det(lmbdaI-A)
eqchar_2 = poly(P2f);    %Coeficientes da equao caracterstica com os polos P2f.

%Aplicando a frmula de Ackerman:
Kf1 = polyvalm(eqchar_1,A)*inv(obsv(A,C))*[0; 0; 1];    %Ganho (transposto) do observador para os polos P1f.
Kf2 = polyvalm(eqchar_2,A)*inv(obsv(A,C))*[0; 0; 1];    %Ganho (transposto) do observador para os polos P2f.

%  Calculo da ao integral

Abarra=[0           1 0 0
        zeros(3,1)  A     ];
    
 Bbarra=[0
         B2] ;
     
 Kbarra=place(Abarra,Bbarra,[P2 -4])   

KI=Kbarra(1);Kc=Kbarra(2:4);


